/**************************************************************************/
/* Erstellen eines Icons fr das Druckerstatus-Programm            v1.35  */
/* Autor      : Thomas Nolte   (24.08.98)                                 */
/* Funktion   : Erstellt ein Programm-Symbol auf der Arbeitsoberflche    */
/*              fr das Druckerstatus-Programm PRNSTAT bzw. SPRNSTAT.     */
/*              Damit knnen versch. Druckerqueues berwacht werden.      */
/* nderungen : - Einbindung einer Fehlerbehandlung           (24.08.98)  */
/*              - jedes Programm erhlt eine Objekt-ID        (27.10.99)  */
/*              - spez. Version fr zwei Programme            (07.11.00)  */
/*              - Objektkonfiguration berarbeitet            (12.01.01)  */
/**************************************************************************/

/* Standard REXX-Utilities */
call RxFuncAdd 'SysLoadFuncs' , 'REXXUTIL' , 'SysLoadFuncs'
call SysLoadFuncs

/* Signal-Bearbeitung */
SIGNAL ON halt NAME Abbruch

/* ANSI-Farben definieren */
Esc=d2c(27)d2c(91)    /* ESC-Zeichen */
/* Attribute */
Bli=esc'5m'           /* blinkend */
Hig=esc'1m'           /* hell */
Non=esc'0m'           /* normal */
Uns=esc'8m'           /* unsichtbar */
/* Vordergrund-Farbe */
Bla=esc'30m'          /* Schwarz */
Red=esc'31m'          /* Rot */
Gre=esc'32m'          /* Grn */
Bro=esc'33m'          /* Gelb */
Blu=esc'34m'          /* Blau */
Cya=esc'35m'          /* Cyan */
Tur=esc'36m'          /* Trkis */
Whi=esc'37m'          /* Wei */
LBla=Hig||esc'30m'    /* Grau*/
LRed=Hig||esc'31m'    /* hell Rot */
LGre=Hig||esc'32m'    /* hell Grn */
LBro=Hig||esc'33m'    /* hell Gelb*/
LBlu=Hig||esc'34m'    /* hell Blau*/
LCya=Hig||esc'35m'    /* hell Cyan*/
LTur=Hig||esc'36m'    /* hell Trlis*/
LWhi=Hig||esc'37m'    /* hell Wei */
/* Hintergrund-Farbe */
BBla=esc'40m'         /* Schwarz */
BRed=esc'41m'         /* Rot */
BGre=esc'42m'         /* Grn */
BBro=esc'43m'         /* Gelb */
BBlu=esc'44m'         /* Blau */
BCya=esc'45m'         /* Cyan */
BTur=esc'46m'         /* Trkis */
BWhi=esc'47m'         /* Wei */

/* Farben einstellen */
say BBla||LTur
call syscls

/* Variablen-Definition */
ProgramName1 = 'PRNSTAT.EXE'
ProgramName2 = 'SPRNSTAT.EXE'
Prog1Icon = 1
Prog2Icon = 1
IconDatei = 'PRNSTAT.ICO'

/* Startmaske */
call SysCls
say LTur" "
say LTur" "
say LTur"        Ŀ"
say LTur"                       Installationsscript                "
say LTur"              Druckerstatus          Datum: "LBro||DATE('E')||LTur"      "
say LTur"        "
say LTur" "
say LTur" "
say LTur"                 Ŀ"
say LTur"                 K  Druckerstatus (8 Queues)"
say LTur"                 "
say LTur"                 Ŀ"
say LTur"                 G  Druckerstatus (64 Queues)"
say LTur"                 "
say LTur"                 Ŀ"
say LTur"                 B  Beide Versionen"
say LTur"                 "
say LTur" "
say LTur" "
call charout ,Non||Whi"Bitte gewnschte Installation angeben (X = Abbruch): "LGre
InstProg = TRANSLATE(SysGetKey())
say LTur" "
say LTur" "

if InstProg = 'X' then
   do 
      say LBro" "
      say LBro"         Ŀ"
      say LBro"          Es werden keine Icons angelegt - Programmende ! "
      say LBro"         "
      say LTur" "
      say LTur" "
      say BBla||Non||Whi
      exit
   end /* do */

if InstProg = 'B' then
   say LTur"Desktop-Icons werden eingerichtet..."
else
   say LTur"Desktop-Icon wird eingerichtet..."
say LTur" "
call syssleep 1

/* Programm suchen */
RC = SysFileTree(ProgramName1,"Ergebnis1","FSO")
RC = SysFileTree(ProgramName2,"Ergebnis2","FSO")

select 
   when (InstProg = 'K' & Ergebnis1.0 = 0) | (InstProg = 'G' & Ergebnis2.0 = 0) then
      do 
         say LRed" "
         say LRed" "
         say LRed"           Ŀ"
         say LRed"            !!! Datei nicht gefunden - Programmende !!! "
         say LRed"           "
         say LRed" "
         say LRed" "
         say BBla||Non||Whi
         call syssleep 3
         exit
      end /* do */
   when InstProg = 'B' & Ergebnis1.0 = 0 & Ergebnis2.0 > 0 then
      do 
         say LRed" "
         say LRed"Programm "LGre||ProgramName1||LRed" nicht gefunden -> kein Icon!"
         Prog1Icon = 0
      end /* do */
   when InstProg = 'B' & Ergebnis1.0 > 0 & Ergebnis2.0 = 0 then
      do 
         say LRed" "
         say LRed"Programm "LGre||ProgramName2||LRed" nicht gefunden -> kein Icon!"
         Prog2Icon = 0
      end /* do */

otherwise
if Ergebnis1.0 = 0 & Ergebnis2.0 = 0 then
   do
      say LRed" "
      say LRed" "
      say LRed"          Ŀ"
      say LRed"           !!! Dateien nicht gefunden - Programmende !!! "
      say LRed"          "
      say LRed" "
      say LRed" "
      say BBla||Non||Whi
      call syssleep 3
      exit
   end
end  /* select */

/* Programm-Icon suchen */
RC = SysFileTree(IconDatei,"IconFile","FO")

if IconFile.0 = '0' then
   do
      say LBro" "
      say LBro" "
      say LBro"        Ŀ"
      say LBro"         Icon-Datei nicht gefunden - erzeuge Standard-Icon! "
      say LBro"        "
      say LBro" "
      say LBro" "
      ProgIcon = ''
   end
else
   do
     ProgIcon = IconDatei
   end

/* Konfiguration fr Objekt */
Klasse = 'WPProgram'
Titel1 = 'Druckerstatus (8)'
Titel2 = 'Druckerstatus (64)'
Ziel = '<WP_DESKTOP>'
ObjektName1 = '<TT_PRNSTAT>'
ObjektName2 = '<TT_SPRNSTAT>'
if ProgIcon = '' then
   do
      Option1 = 'OBJECTID='ObjektName1';EXENAME='Ergebnis1.1
      Option2 = 'OBJECTID='ObjektName2';EXENAME='Ergebnis2.1
   end
else
   do
      Option1 = 'OBJECTID='ObjektName1';EXENAME='Ergebnis1.1';ICONFILE='ProgIcon
      Option2 = 'OBJECTID='ObjektName2';EXENAME='Ergebnis2.1';ICONFILE='ProgIcon
   end
Aktion = 'R'

/* Erzeugen des Objekts */
select
   when InstProg = 'K' then
      do 
         RC = SysCreateObject(Klasse,Titel1,Ziel,Option1,Aktion)
         if RC = '0' then
            say LRed"--> Symbol fr "LGre||Ergebnis1.1||LRed" konnte nicht erstellt werden!"
         else
            say LBro"--> Symbol fr "LGre||Ergebnis1.1||LBro" erfolgreich erstellt!"
      end /* do */
   when InstProg = 'G' then
      do 
         RC = SysCreateObject(Klasse,Titel2,Ziel,Option2,Aktion)
         if RC = '0' then
            say LRed"--> Symbol fr "LGre||Ergebnis2.1||LRed" konnte nicht erstellt werden!"
         else
            say LBro"--> Symbol fr "LGre||Ergebnis2.1||LBro" erfolgreich erstellt!"
      end /* do */

otherwise
if Prog1Icon then
   do
      RC = SysCreateObject(Klasse,Titel1,Ziel,Option1,Aktion)
      if RC = '0' then
         say LRed"--> Symbol fr "LGre||Ergebnis1.1||LRed" konnte nicht erstellt werden!"
      else
         say LBro"--> Symbol fr "LGre||Ergebnis1.1||LBro" erfolgreich erstellt!"
   end
if Prog2Icon then
   do
      RC = SysCreateObject(Klasse,Titel2,Ziel,Option2,Aktion)
      if RC = '0' then
         say LRed"--> Symbol fr "LGre||Ergebnis2.1||LRed" konnte nicht erstellt werden!"
      else
         say LBro"--> Symbol fr "LGre||Ergebnis2.1||LBro" erfolgreich erstellt!"
   end
end  /* select */

say LTur" "
say LTur" "
say BBla||Non||Whi

EXIT

Abbruch:
say LWhi" "
say LWhi" "
say LWhi"Programm durch "LCya"STRG"LWhi" + "LCya"C"LWhi" abgebrochen!"
say LWhi" "
say LWhi" "
say BBLa||Non||Whi
exit

